{ pkgs ? import <nixpkgs> {}}:

let
  # create a modified haskell package set with my package inside it and broken dependencies
  # jailbroken.
  hpkgs = pkgs.haskellPackages.override {
    overrides = hself: hsuper: {
      mateamt = hself.callCabal2nix "mateamt" (gitignore ./.) {};
      pg-transact = with pkgs.haskell.lib;
        doJailbreak (unmarkBroken (dontCheck hsuper.pg-transact));
      hspec-wai-json = with pkgs.haskell.lib;
        doJailbreak (unmarkBroken (dontCheck hsuper.hspec-wai-json));
      token-bucket = with pkgs.haskell.lib;
        doJailbreak (unmarkBroken (dontCheck hsuper.token-bucket));
    };
  };
  gitignore = dir: pkgs.nix-gitignore.gitignoreSource [] dir;
in
  hpkgs.mateamt.env
